package com.qmth.cqb.genpaper.context;

import java.util.LinkedList;
import java.util.List;

import com.qmth.cqb.genpaper.condition.Condition;
import com.qmth.cqb.paper.model.PaperDetailStruct;
import com.qmth.cqb.paper.model.PaperStruct;
import com.qmth.cqb.question.model.Question;

public class PaperContext extends Context {

    private PaperStruct paperStruct;

    private List<DetailContext> details;

    public PaperContext(PaperStruct paperStruct, List<Condition> conditions) {
        super(conditions);
        this.paperStruct = paperStruct;
        this.details = new LinkedList<DetailContext>();
        for (PaperDetailStruct pd : paperStruct.getPaperDetailStructs()) {
            details.add(new DetailContext(pd, this,conditions));
        }
    }

    public boolean check(Question question) {
        return super.check(question);
    }

    public void select(Question question) {
        super.select(question);
    }

    public boolean finish() {
        boolean finish = false;
        for (DetailContext dc : details) {
            finish = dc.finish() && finish;
        }
        return finish;
    }

    public PaperStruct getPaperStruct() {
        return paperStruct;
    }

    public List<DetailContext> getDetails() {
        return details;
    }

}
